using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;
using ZXDT.DBUtility;

namespace ZXDT.CallCenter.DAL
{
    /// <summary>
    /// 数据访问类:T_Call_CheckIDDic
    /// </summary>
    public partial class T_Call_CheckIDDic
    {
        public T_Call_CheckIDDic()
        { }
        #region  Method
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Call_CheckIDDic");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
					new SqlParameter("@F_Id", SqlDbType.Int,4)
			};
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(ZXDT.CallCenter.Model.T_Call_CheckIDDic model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Call_CheckIDDic(");
            strSql.Append("F_CheckId,F_DicId,F_DicName,F_Type)");
            strSql.Append(" values (");
            strSql.Append("@F_CheckId,@F_DicId,@F_DicName,@F_Type)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
					new SqlParameter("@F_CheckId", SqlDbType.Int,4),
					new SqlParameter("@F_DicId", SqlDbType.Int,4),
					new SqlParameter("@F_DicName", SqlDbType.NVarChar,50),
					new SqlParameter("@F_Type", SqlDbType.SmallInt,2)};
            parameters[0].Value = model.F_CheckId;
            parameters[1].Value = model.F_DicId;
            parameters[2].Value = model.F_DicName;
            parameters[3].Value = model.F_Type;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(ZXDT.CallCenter.Model.T_Call_CheckIDDic model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Call_CheckIDDic set ");
            strSql.Append("F_CheckId=@F_CheckId,");
            strSql.Append("F_DicId=@F_DicId,");
            strSql.Append("F_DicName=@F_DicName,");
            strSql.Append("F_Type=@F_Type");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
					new SqlParameter("@F_CheckId", SqlDbType.Int,4),
					new SqlParameter("@F_DicId", SqlDbType.Int,4),
					new SqlParameter("@F_DicName", SqlDbType.NVarChar,50),
					new SqlParameter("@F_Type", SqlDbType.SmallInt,2),
					new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_CheckId;
            parameters[1].Value = model.F_DicId;
            parameters[2].Value = model.F_DicName;
            parameters[3].Value = model.F_Type;
            parameters[4].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Call_CheckIDDic ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
					new SqlParameter("@F_Id", SqlDbType.Int,4)
			};
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool DeleteByCheckId(int F_CheckId, int F_Type)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Call_CheckIDDic ");
            strSql.Append(" where F_CheckId=@F_CheckId and F_Type =@F_Type");
            SqlParameter[] parameters = {
					new SqlParameter("@F_CheckId", SqlDbType.Int,4),
                    new SqlParameter("@F_Type", SqlDbType.Int,4)
			};
            parameters[0].Value = F_CheckId;
            parameters[1].Value = F_Type;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Call_CheckIDDic ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public ZXDT.CallCenter.Model.T_Call_CheckIDDic GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_CheckId,F_DicId,F_DicName,F_Type from T_Call_CheckIDDic ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
					new SqlParameter("@F_Id", SqlDbType.Int,4)
			};
            parameters[0].Value = F_Id;

            ZXDT.CallCenter.Model.T_Call_CheckIDDic model = new ZXDT.CallCenter.Model.T_Call_CheckIDDic();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                if (ds.Tables[0].Rows[0]["F_Id"] != null && ds.Tables[0].Rows[0]["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(ds.Tables[0].Rows[0]["F_Id"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_CheckId"] != null && ds.Tables[0].Rows[0]["F_CheckId"].ToString() != "")
                {
                    model.F_CheckId = int.Parse(ds.Tables[0].Rows[0]["F_CheckId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_DicId"] != null && ds.Tables[0].Rows[0]["F_DicId"].ToString() != "")
                {
                    model.F_DicId = int.Parse(ds.Tables[0].Rows[0]["F_DicId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_DicName"] != null && ds.Tables[0].Rows[0]["F_DicName"].ToString() != "")
                {
                    model.F_DicName = ds.Tables[0].Rows[0]["F_DicName"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_Type"] != null && ds.Tables[0].Rows[0]["F_Type"].ToString() != "")
                {
                    model.F_Type = int.Parse(ds.Tables[0].Rows[0]["F_Type"].ToString());
                }
                return model;
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_CheckId,F_DicId,F_DicName,F_Type ");
            strSql.Append(" FROM T_Call_CheckIDDic ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_CheckId,F_DicId,F_DicName,F_Type ");
            strSql.Append(" FROM T_Call_CheckIDDic ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Call_CheckIDDic ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Call_CheckIDDic T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetList(int PageSize,int PageIndex,string strWhere)
        {
            SqlParameter[] parameters = {
                    new SqlParameter("@tblName", SqlDbType.VarChar, 255),
                    new SqlParameter("@fldName", SqlDbType.VarChar, 255),
                    new SqlParameter("@PageSize", SqlDbType.Int),
                    new SqlParameter("@PageIndex", SqlDbType.Int),
                    new SqlParameter("@IsReCount", SqlDbType.Bit),
                    new SqlParameter("@OrderType", SqlDbType.Bit),
                    new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
                    };
            parameters[0].Value = "T_Call_CheckIDDic";
            parameters[1].Value = "F_Id";
            parameters[2].Value = PageSize;
            parameters[3].Value = PageIndex;
            parameters[4].Value = 0;
            parameters[5].Value = 0;
            parameters[6].Value = strWhere;	
            return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
        }*/

        #endregion  Method
    }
}

